package uniandes.cupi2.cupiCava.mundo;

/**
 * Enuemracin de las posibles presentaciones de vino
 * @author alvar-go
 *
 */
public enum PresentacionVino {

	BARRIL ("Barril"),
	BOTELLA ("Botella");
	
	/**
	 * El nombre de la presentacin
	 */
	private final String nombre;
	
	/**
	 * Construye un nuevo elemento de la enumeracin
	 * @param nNombre el nombre de la presentacin
	 */
	private PresentacionVino(String nNombre) {
		nombre = nNombre;
	}
	
	/**
	 * Devuelve el nombre de la presentacin
	 * @return nombre
	 */
	public String darNombre()
	{
		return nombre;
	}
	
	/**
	 * Representacin en String de un elemento de la enumracin
	 * @return nombre
	 */
	public String toString()
	{
		return nombre;
	}
}
