package uniandes.cupi2.cupiCava.mundo;

/**
 * Enumeracin de los posibles tipos de vino
 * @author alvar-go
 */
public enum TipoVino {

	SECO ("Seco", 0.0),
	ABOCADO ("Abocado", 5.0),
	SEMI_SECO ("Semi Seco", 15.0),
	SEMI_DULCE ("Semi Dulce", 30.0),
	DULCE ("Dulce", 50.0);
	
	/**
	 * Nombre del tipo
	 */
	private final String nombre;
	
	/**
	 * Mnimo nivel de azcar (g/l) del tipo
	 */
	private final double minNivelAzucar;
	
	/**
	 * Crea un nuevo elemento dentro de la enumeracin
	 * @param nNombre el nombre del tipo
	 * @param min el mnimo nivel de azcar g/l del vino
	 */
	private TipoVino(String nNombre, double min) {
		//TODO 1.A Inicialice los parmetros a partir de los atributos
	}
	
	/**
	 * Devuelve el nombre del tipo
	 * @return nombre
	 */
	public String darNombre()
	{
		return nombre;
	}
	
	/**
	 * Devuelve el mnimo nivel de azcar del tipo de vino
	 * @return minNivelAzucar
	 */
	public double darMinNivelAzucar()
	{
		return minNivelAzucar;
	}
	
	/**
	 * Mtodo esttico que define el tipo de un vino a partir de un nivel de azcar dado
	 * @param contenido el contenido de azcar para el que se desea conocer el tipo del vino. contenido >= 0
	 * @return el tipo del vino al que corresponde el contenido de azucar (DULCE, ABOCADO, SEMI_SECO, SEMI_DULCE o DULCE)
	 */
	public static TipoVino darTipoPorCotenidoAzucar(double contenido)
	{
		//TODO 	1.B Calcula y devuelve el tipo de vino segn el contenido de azucar que llega por parmetro
		//		Use como referencia la tabla presentada en la descripcin
	}
	
	/**
	 * Representacin en String de un elemento de la enumeracin
	 * @return nomrbe
	 */
	public String toString()
	{
		return nombre;
	}
}
