/**~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
 * Universidad de los Andes (Bogot - Colombia)
 * Departamento de Ingeniera de Sistemas y Computacin 
 * Licenciado bajo el esquema Academic Free License version 2.1 
 *
 * Proyecto Cupi2 (http://cupi2.uniandes.edu.co)
 * Ejercicio: n7_cupiCava
 * Autor: Equipo Cupi2 2015
 * ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ 
 */
package uniandes.cupi2.cupiCava.mundo;

/**
 * Clase que representa un vino almacenado en la Cupi-Cava.<br>
 * <b>inv: </b> <br>
 * //TODO 6.A Defina el invariante de la clase y documntelo.
 */
public class Vino
{

    // -------------------------------------------------------------
    // Atributos
    // -------------------------------------------------------------

    /**
     * Nombre del vino.
     */
    private String nombre;

    /**
     * Presentacin del vino.
     */
    private PresentacionVino presentacion;

    /**
     * Ao de elaboracin del vino.
     */
    private int anhoElaboracion;

    /**
     * Contenido en azcar del vino (gramos/litro).
     */
    private double contenidoAzucar;

    /**
     * Tipo del vino.
     */
    //TODO 3.A Declare el atributo tipo el cual alamcena el tipo del vino

    /**
     * Color del vino.
     */
    //TODO 3.B Declare el atributo colo el cual almacena el color del vino

    /**
     * Lugar de origen del vino.
     */
    private String lugarOrigen;

    /**
     * Ruta donde se encuentra la imagen del vino.
     */
    private String imagen;

    // -------------------------------------------------------------
    // Constructores
    // -------------------------------------------------------------

    /**
     * Inicializa el vino con la informacin dada por parmetro. <br>
     * <b>post: </b> El vino se inicializ con los valores de nombre, presentacin, ao elaboracin, contenido en azcar, tipo, color, lugar de origen e imagen dados por
     * parmetro.
     * @param pNombre Nombre del vino. pNombre != null && pNombre != "".
     * @param pPresentacion Presentacin del vino. pPresentacion != null && pPresentacion != "" && (pPresentacion == BOTELLA || pPresentacion == BARRIL).
     * @param pAnhoElaboracion Ao de elaboracin del vino. pAnhoElaboracion > 0.
     * @param pContenidoAzucar Contenido en azcar del vino. pContenidoAzucar >= 0
     * @param pTipo Tipo de vino de acuerdo a su contenido en azcar. pTipo != null && pTipo != "" && (pTipo == SECO || pTipo == ABOCADO || pTipo == SEMI_SECO || pTipo ==
     *        SEMI_DULCE || pTipo == DULCE).
     * @param pColor Color del vino. pColor != null && pColor != "" && (pColor == TINTO || pColor == ROSADO || pColor == BLANCO).
     * @param pLugarOrigen Lugar de origen del vino. lugarElaboracion != null y lugarElaboracion != "".
     * @param pImagen Imagen del vino. pImagen != null && pImagen != "".
     */
    public Vino( String pNombre, PresentacionVino pPresentacion, int pAnhoElaboracion, double pContenidoAzucar, ColorVino pColor, String pLugarOrigen, String pImagen )
    {
        nombre = pNombre;
        presentacion = pPresentacion;
        anhoElaboracion = pAnhoElaboracion;
        contenidoAzucar = pContenidoAzucar;
        color = pColor;
        lugarOrigen = pLugarOrigen;
        imagen = pImagen;
        //TODO 3.C Inicialice el atributo tipo. Aproveche el mtodo esttico de la enumeracin TipoVino

    }

    // -------------------------------------------------------------
    // Mtodos
    // -------------------------------------------------------------

    /**
     * Retorna el nombre del vino.
     * @return Nombre del vino.
     */
    public String darNombre( )
    {
        return nombre;
    }

    /**
     * Retorna la presentacin del vino.
     * @return Presentacin del vino.
     */
    public PresentacionVino darPresentacion( )
    {
        return presentacion;
    }

    /**
     * Retorna el ao de elaboracin del vino.
     * @return Ao de elaboracin del vino.
     */
    public int darAnhoElaboracion( )
    {
        return anhoElaboracion;
    }

    /**
     * Retorna el contenido en azcar del vino.
     * @return Contenido en azcar del vino.
     */
    public double darContenidoAzucar( )
    {
        return contenidoAzucar;
    }

    /**
     * Retorna el tipo del vino.
     * @return Tipo del vino.
     */
    public TipoVino darTipo( )
    {
        return tipo;
    }

    /**
     * Retorna el color del vino.
     * @return Color del vino.
     */
    public ColorVino darColor( )
    {
        return color;
    }

    /**
     * Retorna el lugar de origen del vino.
     * @return Lugar de origen del vino.
     */
    public String darLugarOrigen( )
    {
        return lugarOrigen;
    }

    /**
     * Retorna la imagen del vino.
     * @return Imagen del vino.
     */
    public String darImagen( )
    {
        return imagen;
    }


    /**
     * Retorna una cadena con el formato nombre del vino (lugar de origen del vino).
     * @return Representacin del vino en una cadena de caracteres.
     */
    public String toString( )
    {
      //TODO 8.A Complete el mtodo segn la documentacin dada.
    	
    }

    // -----------------------------------------------------------------
    // Invariante
    // -----------------------------------------------------------------

    //TODO 	6.B Cree e implemente el mtodo private void verificarInvariante para validar el invariante definido en 6.A. 
    //		Si es necesario cree mtodos de soporte
    
	
    
}