package uniandes.cupi2.cupiCava.ordenamiento;

/**
 * Enumeracin de los tipos de ordenamiento disponibles en el programa
 * @author alvar-go
 */
public enum Ordenamiento {

	BURBUJA ("Burbuja"),
	SELECCION ("Seleccin"),
	INSERCION ("Insercin"),
	SHAKER("Burbuja bi-direccional"),
	GNOME("Gnomo de jardin");
	
	/**
	 * Nombre del ordenamiento
	 */
	private final String nombre;
	
	/**
	 * Crea un elemento de la enumeracin
	 * @param nNombre el nombre del ordenamiento.
	 */
	private Ordenamiento(String nNombre)
	{
		nombre = nNombre;
	}
	
	/**
	 * Devuelve el nombre el ordenamiento
	 * @return nombre
	 */
	public String darNombre()
	{
		return nombre;
	}
	
	/**
	 * Representacin como String de cada elemento de la enumeracin
	 * @return nombre
	 */
	public String toString()
	{
		return nombre;
	}
	
	
}
