/**~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
 * Universidad de los Andes (Bogot - Colombia)
 * Departamento de Ingeniera de Sistemas y Computacin 
 * Licenciado bajo el esquema Academic Free License version 2.1 
 *
 * Proyecto Cupi2 (http://cupi2.uniandes.edu.co)
 * Ejercicio: n7_cupiCava
 * Autor: Equipo Cupi2 2015
 * ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ 
 */
package uniandes.cupi2.cupiCava.test;

import junit.framework.TestCase;
import uniandes.cupi2.cupiCava.mundo.ColorVino;
import uniandes.cupi2.cupiCava.mundo.PresentacionVino;
import uniandes.cupi2.cupiCava.mundo.TipoVino;
import uniandes.cupi2.cupiCava.mundo.Vino;

/**
 * Clase usada para verificar que los mtodos de la clase Vino estn correctamente implementados.
 */
public class VinoTest extends TestCase
{
    // -------------------------------------------------------------
    // Atributos
    // -------------------------------------------------------------

    /**
     * Clase donde se harn las pruebas.
     */
    private Vino vino1;

  

    // -------------------------------------------------------------
    // Mtodos
    // -------------------------------------------------------------

    /**
     * Escenario 1: Construye dos vinos
     */
    protected void setUp( )
    {
        vino1 = new Vino( "nombre1", PresentacionVino.BARRIL, 1991, 10, ColorVino.BLANCO, "lugar1", "imagen1" );

    }

    /**
     * Prueba 1: Se encarga de verificar el mtodo constructor de la clase.<br>
     * <b> Mtodos a probar: </b> <br>
     * Vino<br>
     * darNombre<br>
     * darPresentacion<br>
     * darAnhoElaboracion<br>
     * darContenidoAzucar<br>
     * darTipo<br>
     * darColor<br>
     * darImagen<br>
     * <b> Caso de prueba 1:</b><br>
     * Construye correctamente el vino, cada uno de los valores corresponde al esperado.<br>
     */
    public void testVino( )
    {

        assertNotNull( "El nombre del vino no fue inicializado.", vino1.darNombre( ) );
        assertEquals( "El nombre del vino no corresponde.", "nombre1", vino1.darNombre( ) );

        assertNotNull( "La presentacin del vino no fue inicializada.", vino1.darPresentacion( ) );
        assertEquals( "La presentacin del vino no corresponde.", PresentacionVino.BARRIL, vino1.darPresentacion( ) );

        assertNotNull( "El ao de elaboracin del vino no fue inicializado.", vino1.darAnhoElaboracion( ) );
        assertEquals( "El ao de elaboracin del vino no corresponde.", 1991, vino1.darAnhoElaboracion( ) );

        assertNotNull( "El contenido en azcar del vino no fue inicializado.", vino1.darContenidoAzucar( ) );
        assertEquals( "El contenido en azcar del vino no corresponde.", 10.0, vino1.darContenidoAzucar( ) );

        assertNotNull( "El tipo del vino no fue inicializado.", vino1.darTipo( ) );
        assertEquals( "El tipo del vino no corresponde.", TipoVino.ABOCADO, vino1.darTipo( ) );

        assertNotNull( "El color del vino no fue inicializado.", vino1.darColor( ) );
        assertEquals( "El color del vino no corresponde.", ColorVino.BLANCO, vino1.darColor( ) );

        assertNotNull( "El lugar de origen del vino no fue inicializado.", vino1.darLugarOrigen( ) );
        assertEquals( "El lugar de origen del vino no corresponde.", "lugar1", vino1.darLugarOrigen( ) );

        assertNotNull( "La imagen del vino no fue inicializado.", vino1.darImagen( ) );
        assertEquals( "La imagen del vino no corresponde.", "imagen1", vino1.darImagen( ) );
    }

}